#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>

/* This is the version number of *this* urlget */
#define URLGET_VERSION "3.12"

#define BUFSIZE (2048*5)

typedef enum {
  URG_OK = 0,
  URG_READ_FAILED,
  URG_COULDNT_CONNECT
} UrgError;

#define URL(url) #url,

static char *toget[] = {
"",
#include "urls"
"",
#include "urls"
"",
#include "urls"
"",
#include "urls"
"",
#include "urls"
NULL
};

/* sendf() sends the formated data to the server */

static int sendf(int fd, char *fmt, ...)
{
  char s[1024];
  va_list ap;
  va_start(ap, fmt);
  vsprintf(s, fmt, ap);
  va_end(ap);
  return(write(fd, s, strlen(s)));
}

/* --- download a stream from a socket --- */

static
UrgError Download(int sockfd, /* socket to read from */
                  long *bytecountp /* return number of bytes read */
                  )
{
  char buf[BUFSIZE];
  size_t nread;
  int bytecount=0;

  for (;;) {
    nread = read(sockfd, buf, BUFSIZE);
    if (nread < 0)
      {
	perror("error reading");
	return URG_READ_FAILED;
      }
    if (nread == 0)
      break;
    bytecount += nread;
  }
  *bytecountp = bytecount;
  return URG_OK;
}


#ifndef IN_SET_LOOPBACK_ADDR
#define	IN_SET_LOOPBACK_ADDR(a) \
	{ (a)->sin_addr.s_addr  = htonl(INADDR_LOOPBACK); \
	(a)->sin_family = AF_INET; }
#endif

UrgError urlget(int port, char *path, long *bytecountp)
{
  struct sockaddr_in serv_addr;
  int sockfd;
  UrgError result;

  sockfd = socket(AF_INET, SOCK_STREAM, 0);

  memset((char *) &serv_addr, '\0', sizeof(serv_addr));
  IN_SET_LOOPBACK_ADDR(&serv_addr);
  serv_addr.sin_port = htons(port);
  
  if (connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
    perror("Can't connect to server");
    close(sockfd);
    return URG_COULDNT_CONNECT;
  }

  /* Send the GET line to the HTTP server */
  sendf(sockfd,
	"GET http://barnowl:8080/%s HTTP/1.0\015\012"
	"Host: 127.0.0.1\015\012"
	"User-Agent: urlget/" URLGET_VERSION "\015\012"
	"Pragma: no-cache\015\012"
	"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\015\012"
	"\015\012",

	path);

  result = Download(sockfd, bytecountp);
  close(sockfd);
  return result;
}

int main(int argc, char **argv)
{
  char **urls;
  long bytes = 0, byte1;

  for (urls = toget; *urls; urls++)
    {
      if (urlget(8080, *urls, &byte1) != URG_OK)
	fprintf(stderr, "failed on %s\n", *urls);
      else
	bytes += byte1;
    }

  fprintf(stderr, "downloaded %d bytes\n", bytes);
  return 0;
}
