#include "cmump.h"
#include <stdio.h>

static int m_cmp(short *aval, int p, short *bval, int q)
{	register neg,i;

	if (p != q) return (p-q);
	if (p == 0) return (0);
	if (p < 0) {neg = 1; p = -p;}
	else neg = 0;

	for (i=p; (--i)>=0;) {
		p = aval[i];
		q = bval[i];
		if (p != q) break;
	}
	if (neg) return(q-p);
	else return(p-q);

}

static m_sub(short *aval, int alen, short *bval, int blen, MINT *c);

/* M_ADD --	adds a and b, yielding c
	Pre:  alen >= blen >= 0
*/

static m_add(short *aval, int alen, short *bval, int blen, MINT *c)
{	register i,x;
	register short @cval = NULL;

	valloc(regionof(c),cval,alen+1);
	x=0;

	for(i=0;i<blen;i++)
	{	x += aval[i] + bval[i];
		cval[i] = x&077777;
		x >>= 15;
#if (! INTR)
		(*PollPtr)();
#endif
	}
	for(;i<alen;i++)
	{	x += aval[i];
		cval[i] = x&077777;
		x >>= 15;
#if (! INTR)
		(*PollPtr)();
#endif
	}
	if(x == 1)
	{	cval[i]=1;
		c->len=i+1;
	}
	else c->len=alen;
	if(c->len==0) cval = NULL;
	c->val=cval;
}

void madd(MINT *a, MINT *b, MINT *c)
{	
	register sign;
	int alen = a->len, blen = b->len;

	sign=1;
	if(alen>=0)
		if(blen>=0)
			if(alen>=blen) m_add(a->val,alen,b->val,blen,c);
			else m_add(b->val,blen,a->val,alen,c);
		else
		{	blen= -blen;
			if (m_cmp(a->val,alen,b->val,blen)>=0) m_sub(a->val,alen,b->val,blen,c);
			else 
			{ 
				sign = -1; 
				m_sub(b->val,blen,a->val,alen,c);
			}
		}
	else	if(blen<=0)
		{	alen = -alen;
			blen= -blen;
			sign= -1;
			if (alen >= blen) m_add(a->val,alen,b->val,blen,c);
			else m_add(b->val,blen,a->val,alen,c);
		}
		else
		{	alen= -alen;
			if (m_cmp(b->val,blen,a->val,alen)>=0) m_sub(b->val,blen,a->val,alen,c);
			else
			{
				sign = -1;
				m_sub(a->val,alen,b->val,blen,c);
			}
		}

	c->len *= sign;
	return;
}

/* M_SUB --	subtracts a and b, yielding c
	Pre:  alen >= blen >= 0 == c->len
*/

static m_sub(short *aval, int alen, short *bval, int blen, MINT *c)
{	register i,x;
	register short @cval = NULL;

	valloc(regionof(c), cval,alen);
	x=0;

	for(i=0;i<blen;i++)
	{	x += aval[i] - bval[i];
		cval[i] = x&077777;
		x >>= 15;
#if (! INTR)
		(*PollPtr)();
#endif
	}
	for(;i<alen;i++)
	{	x += aval[i];
		cval[i] = x&077777;
		x >>= 15;
#if (! INTR)
		(*PollPtr)();
#endif
	}
	for (i=alen; (--i)>=0;) if (cval[i]!=0) break;
	if ((c->len = i+1)==0) cval = NULL;
	c->val = cval;
}

void msub(MINT *a, MINT *b, MINT *c)
{
	register sign;
	int alen = a->len, blen = b->len;

	sign = 1;
	if(alen>=0)
		if(blen>=0)
			if(m_cmp(a->val,alen,b->val,blen)>=0) m_sub(a->val,alen,b->val,blen,c);
			else
			{	sign= -1;
				m_sub(b->val,blen,a->val,alen,c);
			}
		else
		{	blen= -blen;
			if (alen >=blen) m_add(a->val,alen,b->val,blen,c);
			else m_add(b->val,blen,a->val,alen,c);
		}
	else	if(blen<=0)
		{	alen= -alen;
			blen= -blen;
			if (m_cmp(b->val,blen,a->val,alen)>=0) m_sub(b->val,blen,a->val,alen,c);
			else
			{
				sign = -1;
				m_sub(a->val,alen,b->val,blen,c);
			}
		}
		else
		{	alen= -alen;
			if (alen >= blen) m_add(a->val,alen,b->val,blen,c);
			else m_add(b->val,blen,a->val,alen,c);
			sign= -1;
		}
	c->len *= sign;
}

/* HISTORY
 * 18-May-84  Lyle McGeoch (magoo) at Carnegie-Mellon University
 *	Created from code in existing mp package. *
 *	Debugged, cleaned up, and sped up. *
 */
