#ifndef __HEAP
#define __HEAP

#include <stdlib.h>

typedef hstruct heap *Heap;
typedef const char @hstring;
typedef size_t (*cleanup_t)(/* hstruct ??? *x */); /* no args so user can use his type */
typedef size_t (*cleanuparray_t)(/*size_t n, hstruct ??? *x */); /* no args so user can use his type */

Heap newheap(void);
void @halloc(Heap h, size_t size, cleanup_t cleanup);
void @harrayalloc(Heap h, size_t n, size_t size, cleanuparray_t cleanup);
const char @hstralloc(Heap h, size_t size);
const char @hstrdup(Heap h, const char *s);
/*Heap heapof(void @ptr);*/
/* Must call deleteheap with address of local or global (can't take address of
   heap field, so cannot pass an hstruct field...) */
int deleteheap(Heap *h);

extern Heap __heapmap[];

#define heapof(x) (__heapmap[((long)(x) >> 12)])
#define destroy(x) ((*(int *)heapof((x)))--)

#endif
