typedef struct {
        unsigned char max_unaligned_load;
	Symbol (*rmap)(int);

	void (*blkfetch)(int size, int off, int reg, int tmp);
	void (*blkstore)(int size, int off, int reg, int tmp);
	void (*blkloop)(int dreg, int doff,
	                 int sreg, int soff,
	                 int size, int tmps[]);
	void (*_label)(Node);
	int (*_rule)(void@, int);
	short **_nts;
	void (*_kids)(Node, int, Node sameregion *);
	char **_string;
	char **_templates;
	char *_isinstruction;
	char **_ntname;
	void (*emit2)(Node);
	void (*doarg)(Node);
	void (*target)(Node);
	void (*clobber)(Node);
} Xinterface;
extern int     askregvar(Symbol, Symbol);
extern void    blkcopy(int, int, int, int, int, int[]);
extern int     getregnum(Node);
extern int     mayrecalc(Node);
extern int     mkactual(int, int);
extern void    mkauto(Symbol);
extern Symbol  mkreg(char *, int, int, int);
extern Symbol  mkwildcard(Symbol parentptr *);
extern int     move(Node);
extern int     notarget(Node);
extern void    parseflags(int, char **);
extern int     range(Node, int, int);
extern unsigned regloc(Symbol);  /* omit */
extern void    rtarget(Node, int, Symbol);
extern void    setreg(Node, Symbol);
extern void    spill(unsigned, int, Node);
extern int     widens(Node);

extern int      argoffset, maxargoffset;
extern int      bflag, dflag;
extern int      dalign, salign;
extern int      framesize;
extern unsigned freemask[], usedmask[];
extern unsigned hptrmask;
extern unsigned spillmask;
extern int      offset, maxoffset;
extern int      swap;
extern unsigned tmask[], vmask[];
typedef struct {
        unsigned listed:1;
	unsigned registered:1;
	unsigned emitted:1;
	unsigned copy:1;
	unsigned equatable:1;
	unsigned spills:1;
	unsigned mayrecalc:1;
        void @sameregion state;
	short inst;
	Node sameregion kids[3];
	Node sameregion prev, next;
	Node sameregion prevuse;
	short argno;
  	unsigned hptrargmask; /* args that are heap ptrs */
} Xnode;
typedef struct regnode {
  /* regnode in PERM points to symbol in FUNC */
        Symbol vbl;
        short set;
        short number;
        unsigned mask;
} *Regnode;
enum { IREG=0, FREG=1 };
typedef struct {
        const char @parentptr name;
        unsigned int eaddr;  /* omit */
        int offset;
        Node lastuse; /* From PERM to FUNC (converse of p->syms) */
	int usecount;
        Regnode parentptr regnode;
	Symbol parentptr *traditional wildcard;
} Xsymbol;

typedef struct hptrs {
  int offset;
  struct hptrs *sameregion next;
} *Hptrs;
extern Hptrs hptrs;
void hptrauto(int offset);
int ishptr(Symbol p);

enum { RX=2 };
typedef struct {
        int offset;
        unsigned freemask[2];
  	unsigned hptrmask;
	Hptrs sameregion hptrs;
} Env;

#define LBURG_MAX SHRT_MAX

enum { VREG=(45<<4) };

/* Exported for the front end */
extern void             blockbeg(Env *);
extern void             blockend(Env *);
extern void             emit(Node);
extern Node             gen(Node);

extern unsigned         emitbin(Node, int);

#ifdef NDEBUG
#define debug(x) 0
#else
#define debug(x) (dflag&&((x),0))
#endif
