#include "c.h"

static char rcsid[] = "$Id: list.c,v 1.1.1.1 2001/06/28 19:46:59 dgay Exp $";

static List freenodes;          /* free list nodes */

/* append - append x to list, return new list */
List append(void @x, List list) {
        List new = 0;

        if ((new = freenodes) != NULL)
                freenodes = freenodes->link;
        else
                NEW0(new, PERM);
        if (list) {
                new->link = list->link;
                list->link = new;
        } else
                new->link = new;
        new->x = x;
        return new;
}

/* length - # elements in list */
int length(List list) {
        int n = 0;

        if (list) {
                List lp = list;
                do
                        n++;
                while ((lp = lp->link) != list);
        }
        return n;
}

/* ltov - convert list to an NULL-terminated vector allocated in arena */
void @ltov(List *list, unsigned arena) {
        int i = 0;
        void @@array = 
	  rarrayalloc(heap[arena], length(*list) + 1, typeof(array[0]));

        if (*list) {
                List lp = *list;
                do {
                        lp = lp->link;
                        array[i++] = lp->x;
			lp->x = 0;
                } while (lp != *list);
#ifndef PURIFY
                lp = (*list)->link;
                (*list)->link = freenodes;
                freenodes = lp;
#endif
        }
        *list = NULL;
        /*array[i] = NULL;*/
        return array;
}
