/*
 * Copyright (c) 1992-2001 David Gay and
 *      The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef REGIONS_H
#define REGIONS_H

#include <stdlib.h>

typedef struct region **region;

typedef int type_t;

#define rctypeof(t) 0

region newregion(void);
#define newsubregion(parent) newregion()
#define ralloc(r, type) ((type *)int_ralloc((r), sizeof(type)))
#define rarrayalloc(r, n, type) ((type *)int_rarrayalloc((r), (n), sizeof(type)))
void *int_ralloc(region r, size_t size);
void *int_rarrayalloc(region r, size_t n, size_t size);
char *rstralloc(region r, size_t size);
char *rstrdup(region r, const char *s);
/*region regionof(void *ptr);*/
void deleteregion(region r);
void deleteregion_ptr(region *r);

#define rarraycopy(to, from, n, type) memcpy((to), (from), (n) * sizeof(type))

/* Low-level alloc with dynamic type info */
/*void *typed_ralloc(region r, size_t size, type_t type);*/
#define typed_ralloc(r, size, type) ((type), int_ralloc((r), (size)))

/*void *typed_rarrayalloc(region r, size_t n, size_t size, type_t type);*/
#define typed_rarrayalloc(r, n, size, type) ((type), int_rarrayalloc((r), (n), (size)))

/*void typed_rarraycopy(void *to, void *from, size_t n, size_t size, type_t type);*/
#define typed_rarraycopy(to, from, n, size, type) ((type), memcpy((to), (from), (n) * (size)))

typedef void *(*nomem_handler)(void);
nomem_handler set_nomem_handler(nomem_handler newhandler);

#endif
